/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest{}

// AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest struct for AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest
type AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest struct {
	Service *string                    `json:"service,omitempty"`
	Data    *TikTokStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest instantiates a new AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest() *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest {
	this := AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest{}
	var service string = "tik_tok_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest {
	this := AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest{}
	var service string = "tik_tok_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) GetData() TikTokStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret TikTokStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) GetDataOk() (*TikTokStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given TikTokStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) SetData(v TikTokStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest struct {
	value *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) Get() *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) Set(val *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest(val *AppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) *NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerTikTokStaticTikTokStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
